﻿IF (OBJECT_ID('dlv.SysProfileData_backup') IS NOT NULL)
   	DROP TABLE dlv.SysProfileData_backup;

SELECT
	*
INTO dlv.SysProfileData_backup
FROM SysProfileData;

WITH cte AS (
	SELECT
		MAX(ModifiedOn) AS MaxModifiedOn,
		ContactId,
		SysCultureId,
		[Key]
	FROM SysProfileData
	WHERE [Key] IS NOT NULL
		AND [Key] <> ''
	GROUP BY ContactId,
			 SysCultureId,
			 [Key]
	HAVING COUNT(ContactId) > 1
)
DELETE spd
FROM SysProfileData spd
JOIN cte ON cte.[Key] = spd.[Key]
	AND (
		cte.SysCultureId = spd.SysCultureId
		OR cte.SysCultureId IS NULL AND spd.SysCultureId IS NULL
	)
	AND (
		cte.ContactId = spd.ContactId
		OR cte.ContactId IS NULL AND spd.ContactId IS NULL
	)
	AND cte.MaxModifiedOn != spd.ModifiedOn;

SELECT @@rowcount;