﻿function DisablePortalDataService () {
	param (
		[Parameter(Mandatory = $true)]
		[string]$webRootDirectory
	)
	$configPath = $webRootDirectory + "\Terrasoft.WebApp\web.config"
	$key = "UsePortalDataService"
	$value = "false"

	Write-Host "Sets app-setting '$key' to '$value'"
	$doc = New-Object System.Xml.XmlDocument
	$doc.Load($configPath)
	$appSettings = $doc.SelectSingleNode('configuration/appSettings')
	$node = $appSettings.SelectSingleNode('add[@key="' + $key + '"]')
	if ($node -eq $null) {
		$node = $appSettings.OwnerDocument.CreateElement("add")
		[void]$appSettings.AppendChild($node)
		$node.SetAttribute("key", $key)
	}
	$node.SetAttribute("value", $value)
	$doc.Save($configPath)
}