﻿IF (SELECT TOP (1) 1 FROM SysLic) IS NULL
	RETURN;

--region TriggerReportDevExpress
IF OBJECT_ID('TRReportDevExpress', 'TR') IS NOT NULL
   	DROP TRIGGER TRReportDevExpress;
    
DECLARE @CreateTriggerReportDevExpress NVARCHAR(MAX) =
'CREATE TRIGGER TRReportDevExpress ON SysSchema
FOR UPDATE
AS 
BEGIN
	SET NOCOUNT ON;

	DECLARE @Id UNIQUEIDENTIFIER;
	DECLARE @SysPackageId UNIQUEIDENTIFIER;
	DECLARE @MetaData VARBINARY(MAX);
	DECLARE @ManagerName NVARCHAR(250);
	DECLARE @Name NVARCHAR(250);

	SELECT
		@Id = Id,
		@SysPackageId = SysPackageId,
		@MetaData = MetaData,
		@ManagerName = ManagerName,
		@Name = Name
	FROM DELETED;

	IF @ManagerName = ''ReportSchemaManager'' AND UPDATE(MetaData)
	BEGIN
		PRINT ''Rollback changes for DevExpress report '' + QUOTENAME(@Name) + '' in package "'' + CAST(@SysPackageId AS NVARCHAR(MAX)) + ''"'';
		UPDATE SysSchema
		SET MetaData = @MetaData
		WHERE Id = @Id;
    END
END';
EXEC(@CreateTriggerReportDevExpress);
--endregion

--region TriggerReportWord
IF OBJECT_ID('TRReportWord', 'TR') IS NOT NULL
   	DROP TRIGGER TRReportWord;

DECLARE @CreateTriggerReportWord NVARCHAR(MAX) =
'CREATE TRIGGER TRReportWord ON SysModuleReport
FOR UPDATE
AS 
BEGIN
	SET NOCOUNT ON;

	DECLARE @WordReportTypeId UNIQUEIDENTIFIER = ''8bc259ef-4276-4906-b7a6-23dc59be7fe2'';
	DECLARE @Id UNIQUEIDENTIFIER;
	DECLARE @File VARBINARY(MAX);
	DECLARE @TypeId UNIQUEIDENTIFIER;
	DECLARE @FileName NVARCHAR(250);

	SELECT
		@Id = Id,
		@File = [File],
		@TypeId = TypeId,
		@FileName = FileName
	FROM DELETED;

	IF @TypeId = @WordReportTypeId AND UPDATE([File])
	BEGIN
		PRINT ''Rollback changes for Word report '' + QUOTENAME(@FileName);
		UPDATE SysModuleReport
		SET [File] = @File
		WHERE Id = @Id;
    END
END';
EXEC(@CreateTriggerReportWord);
--endregion