-- delete new records, previously deleted
IF (SELECT TOP (1) 1 FROM SysLic) IS NULL
	RETURN;

DECLARE @sqlText NVARCHAR(MAX);
DECLARE @RecordId UNIQUEIDENTIFIER;
DECLARE	@TableName SYSNAME;
DECLARE tableNameCursor CURSOR LOCAL FOR
	SELECT DISTINCT
		tmp.TableName
	FROM dlv_LookupData tmp
	JOIN sys.tables t ON t.name = tmp.TableName -- where object_id(tmp.TableName) is not null
	ORDER BY tmp.TableName;
OPEN tableNameCursor;
FETCH NEXT FROM tableNameCursor INTO @TableName;
WHILE @@FETCH_STATUS = 0
BEGIN
	PRINT 'Clear table ' + QUOTENAME(@tableName);
	DECLARE recordIdCursor CURSOR LOCAL FOR
		SELECT
			RecordId
		FROM dlv_LookupData
		WHERE TableName = @TableName;
	OPEN recordIdCursor;
	FETCH NEXT FROM recordIdCursor INTO @RecordId;
	WHILE @@FETCH_STATUS = 0
	BEGIN
		SET @sqlText = CONCAT('DELETE FROM ', QUOTENAME(@TableName), ' WHERE Id = ', QUOTENAME(@RecordId, ''''));
		EXEC dlv.tsp_Execute @sqlText, 1;
		FETCH NEXT FROM recordIdCursor INTO @RecordId;
	END
	CLOSE recordIdCursor;
	DEALLOCATE recordIdCursor;
	FETCH NEXT FROM tableNameCursor INTO @TableName;
END
CLOSE tableNameCursor;
DEALLOCATE tableNameCursor;

IF OBJECT_ID('dlv_LookupData') IS NOT NULL
	DROP TABLE dlv_LookupData;