IF (SELECT TOP (1) 1 FROM SysLic) IS NULL
	RETURN;

IF OBJECT_ID('SysProfileData_backup') IS NULL
	RETURN;

BEGIN TRY
	BEGIN TRAN

	INSERT INTO [SysProfileData]
	SELECT * FROM [SysProfileData_backup] [spd_b]
	WHERE [spd_b].[ContactId] IS NOT NULL
		AND [spd_b].[Id] NOT IN (SELECT [Id] FROM [SysProfileData]);

	UPDATE [spd]
	SET [spd].[ObjectData] = [spd_b].[ObjectData]
	FROM [SysProfileData_backup] [spd_b]
		INNER JOIN [SysProfileData] [spd] ON [spd].[Key] = [spd_b].[Key]
			AND [spd].[SysCultureId] = [spd_b].[SysCultureId]
			AND [spd_b].[ContactId] IS NULL
			AND [spd].[ContactId] IS NULL
			AND [spd_b].[Key] IN (
				SELECT [Key]
				FROM [SysProfileData_backup]
				WHERE [Key] <> ''
				GROUP BY [Key], [ObjectData]
				HAVING COUNT([ObjectData]) > 1
			);

	INSERT INTO [SysProfileData]
	SELECT * FROM [SysProfileData_backup] [spd_b]
	WHERE [spd_b].[Id] NOT IN (SELECT [Id] FROM [SysProfileData])
		AND NOT EXISTS (SELECT Id 
			FROM [SysProfileData] [spd] 
			WHERE [spd].[Key] = [spd_b].[Key]
				AND [spd].[ContactId] IS NULL
			AND [spd_b].[ContactId] IS NULL);

	DROP TABLE [SysProfileData_backup];

	COMMIT;
END TRY
BEGIN CATCH
	IF @@TRANCOUNT > 0
		ROLLBACK;
	PRINT ERROR_MESSAGE();
END CATCH